/* Author : Dario GENGA
 * Date : 23.11.2021
 * Description : Library to manipulate the stack
 */

#include <stdio.h>
#include <stdlib.h>
#include "stack.h"
#define  ARGS_MIN 2
#define  ARG_INDEX_array_size 1


void print_array(int *array, int array_size) {
    for (int i = 0; i < array_size; i++) {
        printf("%d ", array[i]);
    }
    printf("\n");
}

int main(int argc, char **argv) {
    if (argc < ARGS_MIN) {
        printf("Missing arguments.\n");
        return EXIT_FAILURE;
    }

    int array_size = atoi(argv[ARG_INDEX_array_size]);

    if (array_size != argc - ARGS_MIN || array_size == 0) {
        printf("The number of element must correspond to the size of the array.\n");
        return EXIT_FAILURE;
    }
    int *array = malloc(array_size * sizeof(int));

    for (int i = 0; i < argc - ARGS_MIN; i++) {
        array[i] = atoi(argv[i + ARGS_MIN]);
    }
    int* sorted_array = sort(array, array_size);
    print_array(sorted_array, array_size);

    free(sorted_array);
    free(array);
    return EXIT_SUCCESS;
}